<template>
  <b-card class="animated fadeIn" title="Cập nhật thông tin đại lý">
    <div v-if="agency!=null">
    <b-form @submit.prevent="validateBeforeSubmit">
         <b-row>
        <b-col sm="12">
        <button size="lg" type="button" @click.stop="confirmDelete()" class="pull-right btn btn-outline-danger ml-1"><i class="fa fa-exclamation-triangle fa-lg"></i> Delete</button>
        <button size="lg" class="pull-right btn btn-success" ><i class="fa fa-save fa-lg"></i> Save</button>

        </b-col>
    </b-row>
    <b-row>
      <b-col sm="6">
        
        <b-form-group>
          <label for="agency_name">Tên đại lý</label>
          <b-form-input type="text" id="name" name="agency_name" v-model="agency.name" data-vv-as="Tên đại lý" v-validate="'required'" :class="{'is-invalid': errors.has('agency_name')}"></b-form-input>
          <span v-show="errors.has('agency_name')" class="form-text text-muted text-danger">{{ errors.first('agency_name') }}</span>
        </b-form-group>
        <b-form-group>
          <label>Tỉnh thành</label>
          <select class="form-control" v-model="agency.province_id" v-validate="'required'" data-vv-as="Tỉnh/Thành" name="province_id" :class="{'is-invalid': errors.has('province_id')}" @change="fetchDistricts()">
          <option v-if="agency.province != null" :value="agency.province.id">{{ agency.province.name }}</option>
            <option v-for="province in provinces" :key="province.id" :value="province.id">{{ province.name }}</option>
          </select>
           <span v-show="errors.has('province_id')" class="form-text text-muted text-danger">{{ errors.first('province_id') }}</span>
        </b-form-group>
        <b-form-group>
          <label for="district_id">Quận/Huyện</label>
          <select class="form-control" v-model="agency.district_id" v-validate="'required'" data-vv-as="Quận/Huyện" name="district_id" :class="{'is-invalid': errors.has('district_id')}" @change="fetchWards()">
            <option  v-if="agency.district != null" :value="agency.district.id">{{ agency.district.name }}</option>
            <option v-if="districts!=null" v-for="district in districts" :key="district.id" :value="district.id">{{ district.name }}</option>
          </select>
          <span v-show="errors.has('district_id')" class="form-text text-muted text-danger">{{ errors.first('district_id') }}</span>
        </b-form-group>
        <b-form-group>
          <label for="ward_id">Xã/Phường</label>
          <select class="form-control" data-vv-as="Xã/Phường" name="ward_id" v-validate="'required'" :class="{'is-invalid': errors.has('ward_id')}" v-model="agency.ward_id">
          <option  v-if="agency.ward != null" :value="agency.ward.id" selected>{{ agency.ward.name }}</option>
            <option v-if="wards!=null" v-for="ward in wards" :key="ward.id" :value="ward.id">{{ ward.name }}</option>
          </select>
          <span v-show="errors.has('ward_id')" class="form-text text-muted text-danger">{{ errors.first('ward_id') }}</span>
        </b-form-group>
        <b-form-group>
          <label for="address">Địa chỉ</label>
          <b-form-input type="text" name="address" v-model="agency.address" data-vv-as="Địa chỉ" v-validate="'required'" :class="{'is-invalid': errors.has('address')}"></b-form-input>
          <span v-show="errors.has('address')" class="form-text text-muted text-danger">{{ errors.first('address') }}</span>
        </b-form-group>
        <b-form-group>
          <label for="vat">Nhân viên phụ trách</label>
          <v-select v-if="salesmen!=null" :options="salesmen" name="salesman" label="name" v-model="selectedSalesman"  data-vv-as="Nhân viên giao dịch" v-validate="'required'">
            <template slot="option" slot-scope="option">
              <span><img src="https://ui-avatars.com/api/?background=0D8ABC&color=fff&name=ABC&size=48" class="img-thumbnai"></span>
              {{ option.name }}
            </template>
          </v-select>
           <span v-show="errors.has('salesman')" class="form-text text-muted text-danger">{{ errors.first('salesman') }}</span>
        </b-form-group>
      </b-col>
      <b-col sm="6">
        <b-form-group>
          <label for="owner_name">Tên chủ cửa hàng</label>
          <b-form-input type="text" id="owner_name" v-model="customer.fullname" v-validate="'required'" data-vv-as="Tên chủ cửa hàng" name="owner_name" :class="{'is-invalid': errors.has('owner_name')}"></b-form-input>
          <span v-show="errors.has('owner_name')" class="form-text text-muted text-danger">{{ errors.first('owner_name') }}</span>
        </b-form-group>
        <b-form-group>
          <label for="email">Email</label>
          <b-form-input type="email" id="email" v-model="customer.email" v-validate="'email'" data-vv-as="Email" name="email" :class="{'is-invalid': errors.has('email')}"></b-form-input>
          <span v-show="errors.has('email')" class="form-text text-muted text-danger">{{ errors.first('email') }}</span>
        </b-form-group>
        <b-form-group>
          <label for="phone_number">SĐT</label>
          <b-form-input type="text" id="phone_number" data-vv-as="SĐT" v-validate="'required|min:9'" v-model="customer.phone_number" name="phone_number" :class="{'is-invalid': errors.has('phone_number')}"></b-form-input>
           <span v-show="errors.has('phone_number')" class="form-text text-muted text-danger">{{ errors.first('phone_number') }}</span>
        </b-form-group>
         <b-form-group>
          <label>Giới tính</label>
           <b-form-select v-model="customer.gender" :options="genders"></b-form-select>
        </b-form-group>
       

      </b-col>
    </b-row>

    </b-form>
    </div>
    <div v-else>
      <span class="text-info">{{ msg }}</span>
    </div>
  </b-card>
</template>
<script>
import {http} from '@/services'
import vSelect from 'vue-select'
import {alerts} from '@/utils'

  export default {
    components: {
      vSelect
    },
    data() {
      return {
        agency: null,
        customer: {
          id: '',
          fullname: '',
          email: '',
          phone_number: '',
          gender: 1
        },
        genders: [{
            value: 1,
            text: 'Nam'
          },
          {
            value: 2,
            text: 'Nữ'
          }
        ],
        provinces: null,
        districts: null,
        wards: null,
        salesmen: null,
        selectedSalesman: null,
        validations: {

        },
        msg :" Đang tải thông tin đại lý... "
      }
    },
    created() {
      this.fetchAgency();
      this.fetchProvinces()
      this.fetchSalesmen()
    },
    methods: {
      fetchAgency() {
        http.post('/agency', {
          id: this.$route.params.agencyId
        }, (response) => {
          if(Object.keys(response.data).length>0)
          {
            this.agency = response.data;
            if (this.agency.owner) {
              this.customer = this.agency.owner;
            }
            if(this.agency.salesman!=null){
              this.selectedSalesman = this.agency.salesman
            }
            if(this.agency.province_id == null){
              this.agency.province_id = 0;
              this.agency.district_id = 0;
              this.agency.ward_id = 0;

            }
            
          }else{
            this.msg = "Không tìm thấy thông tin đại lý.";
          }

        })
      },
      fetchProvinces() {
        http.get('/provinces', (response) => {
          this.provinces = response.data;
        })
      },
      fetchDistricts() {
        http.post('/provinces/districts', {
          province_id: this.agency.province_id
        }, (response) => {
          this.districts = response.data;
        })
      },
      fetchWards() {
        http.post('/districts/wards', {
          district_id: this.agency.district_id
        }, (response) => {
          this.wards = response.data;
        })
      },
      fetchSalesmen() {
        http.get('/salesman', (response) => {
          this.salesmen = response.data;
        })
      },
      async save() {
        return new Promise((resolve, reject) => {
          if (this.selectedSalesman != null) {
            this.agency.sale_id = this.selectedSalesman.id;
          }
          http.post('/agency/update', {
            agency: this.agency,
            customer: this.customer
          }, (response) => {
            //return setTimeout(resolve(response.data),3000)
            return resolve(response.data)
          })
        })

      },
      async deleteAgency(){
        return new Promise((resolve, reject)=>{
        http.post('/agency/delete', {
            id: this.agency.id
          }, (response) => {
            return resolve(response.data);
          }, (response)=>{
            return reject(response);
          })
        })

      },
      confirmDelete() {
        alerts.ajaxConfirm('Bạn chắc chắn muốn xóa đại lý này?', 'warning', this.deleteAgency)
      },
      validateBeforeSubmit() {
        this.$validator.validateAll().then((result) => {
          if (result) {

            // eslint-disable-next-line
            alerts.ajaxConfirm('Xác nhận lưu thông tin đại lý', 'info', this.save);
            return;
          }

          // alert('Correct them errors!');
        });
      }
    }
  }
</script>
